

Patch from Rik van Riel <riel@conectiva.com.br>

the following patch, against today's BK tree, fixes a small
SMP race in disassociate_ctty.  This function gets called
from do_exit, without the BKL held.

However, it sets the *tty variable before grabbing the bkl,
then makes decisions on what the variable was set to before
the lock was grabbed, despite the fact that another process
could modify its ->tty pointer in this same function.



 char/tty_io.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletion(-)

diff -puN drivers/char/tty_io.c~disassociate_tty-fix drivers/char/tty_io.c
--- 25/drivers/char/tty_io.c~disassociate_tty-fix	2003-02-09 02:47:09.000000000 -0800
+++ 25-akpm/drivers/char/tty_io.c	2003-02-09 02:47:09.000000000 -0800
@@ -581,7 +581,7 @@ EXPORT_SYMBOL(tty_hung_up_p);
  */
 void disassociate_ctty(int on_exit)
 {
-	struct tty_struct *tty = current->tty;
+	struct tty_struct *tty;
 	struct task_struct *p;
 	struct list_head *l;
 	struct pid *pid;
@@ -589,6 +589,7 @@ void disassociate_ctty(int on_exit)
 
 	lock_kernel();
 
+	tty = current->tty;
 	if (tty) {
 		tty_pgrp = tty->pgrp;
 		if (on_exit && tty->driver.type != TTY_DRIVER_TYPE_PTY)

_
